# Getting Help

Writing distributed applications is hard, and sometimes you need help. There are several ways to get in
touch with the developers behind MassTransit. In most cases, you can expect a response within a few days,
sometimes sooner. The speed of the response is going to depend upon how well you've done your homework
before raising the white flag.

However, before attempting to contact a developer directly, there are many active forums for support
that are available.

## Stack Overflow

There is a MassTransit tag on [Stack Overflow][1], which has many questions that have already been asked.
Several developers regularly monitor this tag for new questions, so that's a great place to start. Be sure
to search and see if your question has already been asked, that is the fastest way to an answer if someone
else has already experienced the same issue.

Before you just post your question, however, spend a few moments to compose your thoughts and formulate your
question. There is nothing as pointless as simply telling us "MassTransit does not work for me" with no further
information to give any clue to why. Before you post, search the web to see if your question has already been
asked or even answered. And if it has been, you will already have your answer.

## Mailing List

A long history of support is available on the mailing list, which is hosted on [Google Groups][2]. There are
a wide variety of developers using MassTransit on the list, and often times they can help. If you are going to
use MassTransit, joining the mailing list is a great way to participate in the community.

When posting on the mailing list, pick a good subject line, and if the subject of the thread changes, please
change the subject to match. Some of us deal with hundreds of emails per day and we need all the help we can
get to pick the interesting or important ones.

Also, if you are seeing some unexpected behavior, generate a [diagnostic result](configuration/diagnostics.md) and 
post it as a [Gist][4] so that it can be reviewed (mail attachments rarely work, so avoid them). 
This will help a lot towards understanding how your configuration is setup.

## Gitter

Our chat room at [Gitter](https://gitter.im/MassTransit/home) is becoming more and more popular.
There you can find people who use MassTransit in their systems and can provide you with quick advise. 
Get engaged, get help and help others too!

## Twitter

A fast way to get our attention is on Twitter, by shooting a tweet tagged `#mtproj`. Assuming you can fit your
question in 140 characters or less. A few of us have saved searches on this tag, which makes questions easy to find
(strangely, MassTransit is the worst term to search -- go figure). There are several spread out across the US, so
think about the time zone when you tweet. Again, post a link to a [Gist][4] with source, configuration, log files, etc.
If it is complex, it's likely you'll be pushed to hit the mailing list.

## GitHub Issues

Please **do not open an issue on GitHub**, unless you have spotted an actual bug in MassTransit. If you are unsure,
ask on the [mailing list][2] or on [StackOverflow][1], and if we confirm it's a bug, we'll ask you to [create the issue][3]. 

**Issues are not the place for questions, and they'll likely be closed.**

This policy is in place to avoid bugs being drowned out in a pile of sensible suggestions for future enhancements
and calls for help from people who forget to check back if they get it and so on.

[1]: http://stackoverflow.com/questions/tagged/masstransit
[2]: http://groups.google.com/group/masstransit-discuss/
[3]: https://github.com/masstransit/masstransit/issues
[4]: https://gist.github.com/