﻿// Copyright 2007-2013 Chris Patterson
//  
// Licensed under the Apache License, Version 2.0 (the "License"); you may not use
// this file except in compliance with the License. You may obtain a copy of the 
// License at 
// 
//     http://www.apache.org/licenses/LICENSE-2.0 
// 
// Unless required by applicable law or agreed to in writing, software distributed
// under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR 
// CONDITIONS OF ANY KIND, either express or implied. See the License for the 
// specific language governing permissions and limitations under the License.
namespace MassTransit.Steward.Contracts.Availability
{
    using System;


    /// <summary>
    /// A heartbeat is sent by the leader every interval to continue to assert its
    /// leadership position in the community
    /// </summary>
    public interface Heartbeat
    {
        /// <summary>
        /// The timestamp this heartbeat was generated (utc, duh)
        /// </summary>
        DateTime Timestamp { get; }

        /// <summary>
        /// Identifies the current leader
        /// </summary>
        Node Leader { get; }

        /// <summary>
        /// The current term of this leader
        /// </summary>
        long Term { get; }

        /// <summary>
        /// The interval between heartbeats
        /// </summary>
        TimeSpan HeartbeatInterval { get; }
    }
}