﻿// Copyright 2007-2016 Chris Patterson, Dru Sellers, Travis Smith, et. al.
//  
// Licensed under the Apache License, Version 2.0 (the "License"); you may not use
// this file except in compliance with the License. You may obtain a copy of the 
// License at 
// 
//     http://www.apache.org/licenses/LICENSE-2.0 
// 
// Unless required by applicable law or agreed to in writing, software distributed
// under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR 
// CONDITIONS OF ANY KIND, either express or implied. See the License for the 
// specific language governing permissions and limitations under the License.
namespace MassTransit.Serialization
{
    using System;


    /// <summary>
    /// The content of a serialized message
    /// </summary>
    public interface SerializedMessage
    {
        /// <summary>
        /// The destination for the serialized message
        /// </summary>
        Uri Destination { get; }

        /// <summary>
        /// The content type of the serializer used
        /// </summary>
        string ContentType { get; }

        string ExpirationTime { get; }
        string ResponseAddress { get; }
        string FaultAddress { get; }
        string Body { get; }
        string MessageId { get; }
        string RequestId { get; }
        string CorrelationId { get; }
        string ConversationId { get; }
        string InitiatorId { get; }
        string HeadersAsJson { get; }
        string PayloadMessageHeadersAsJson { get; }
    }
}